Imports SolidWorks.Interop.sldworks
Imports SolidWorks.Interop.swconst

Partial Class SolidWorksMacro
    Public Sub main()
        swApp.SendMsgToUser2(getNames(swApp.ActiveDoc, " "), swMessageBoxIcon_e.swMbInformation, swMessageBoxBtn_e.swMbOk)
    End Sub
    Function getNames(ByVal swMod As ModelDoc2, ByRef s As String) As String
        For Each c As Component2 In swMod.GetComponents(True)
            If (c.GetPathName.ToUpper.EndsWith(".SLDASM") AndAlso getNames(c.GetModelDoc2, s) = "") OrElse (swMod.FeatureByName(c.Name2).getchildren IsNot Nothing) Then
                For Each ch As Feature In swMod.FeatureByName(c.Name2).getchildren()
                    s &= ch.Name & vbNewLine
                Next
            End If
        Next
        Return s
    End Function
    Public swApp As SldWorks
End Class
